VERSION 5.00
Begin VB.Form Base 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Stereo DeethScope"
   ClientHeight    =   7110
   ClientLeft      =   3810
   ClientTop       =   1605
   ClientWidth     =   9855
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   474
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   657
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Scope 
      BackColor       =   &H80000009&
      ForeColor       =   &H80000002&
      Height          =   768
      Index           =   1
      Left            =   1656
      ScaleHeight     =   256
      ScaleMode       =   0  'User
      ScaleWidth      =   123
      TabIndex        =   6
      Top             =   468
      Visible         =   0   'False
      Width           =   1524
   End
   Begin VB.Frame Stuff 
      BorderStyle     =   0  'None
      Height          =   336
      Left            =   72
      TabIndex        =   2
      Top             =   1296
      Width           =   3360
      Begin VB.CommandButton StartButton 
         Caption         =   "&Start"
         Height          =   336
         Left            =   0
         TabIndex        =   5
         Top             =   0
         Width           =   804
      End
      Begin VB.CommandButton StopButton 
         Caption         =   "S&top"
         Enabled         =   0   'False
         Height          =   336
         Left            =   840
         TabIndex        =   4
         Top             =   0
         Width           =   804
      End
      Begin VB.CheckBox Flicker 
         Caption         =   "Flickerless"
         Height          =   300
         Left            =   1680
         TabIndex        =   3
         Top             =   0
         Width           =   1632
      End
   End
   Begin VB.PictureBox Scope 
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000002&
      Height          =   768
      Index           =   0
      Left            =   72
      ScaleHeight     =   256
      ScaleMode       =   0  'User
      ScaleWidth      =   123
      TabIndex        =   1
      Top             =   468
      Width           =   1524
   End
   Begin VB.ComboBox DevicesBox 
      Height          =   288
      Left            =   72
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   72
      Width           =   3108
   End
   Begin VB.Shape Shape 
      BackColor       =   &H00C00000&
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   1188
      Left            =   0
      Top             =   0
      Width           =   1812
   End
End
Attribute VB_Name = "Base"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------------
' Deeth Stereo Oscilloscope v1.0
' A simple oscilloscope application -- now in <<stereo>>
'----------------------------------------------------------------------
' Opens a waveform audio device for 8-bit 11kHz input, and plots the
' waveform to a window.  Can only be resized to a certain minimum
' size defined by the Shape box.
'----------------------------------------------------------------------
' It would be good to make this use the same double-buffering
' scheme as the Spectrum Analyzer.
'----------------------------------------------------------------------
' Murphy McCauley (MurphyMc@Concentric.NET) 08/12/99
'----------------------------------------------------------------------

Option Explicit

Private Const BLEN = 32768
Private DevHandle As Long
'Private InData(0 To 511) As Byte
Private InData(0 To BLEN) As Integer
Private SyncData(0 To 511) As Byte
Private Inited As Boolean
Public MinHeight As Long, MinWidth As Long

Private XScale As Single
Private YScale As Single
Private XCal As Single
Private YCal As Single
Private RawXY As Boolean

Private Type WaveFormatEx
    FormatTag As Integer
    Channels As Integer
    SamplesPerSec As Long
    AvgBytesPerSec As Long
    BlockAlign As Integer
    BitsPerSample As Integer
    ExtraDataSize As Integer
End Type

Private Type WaveHdr
    lpData As Long
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    dwLoops As Long
    lpNext As Long 'wavehdr_tag
    Reserved As Long
End Type

Private Type WaveInCaps
    ManufacturerID As Integer      'wMid
    ProductID As Integer       'wPid
    DriverVersion As Long       'MMVERSIONS vDriverVersion
    ProductName(1 To 32) As Byte 'szPname[MAXPNAMELEN]
    Formats As Long
    Channels As Integer
    Reserved As Integer
End Type

Private Const WAVE_INVALIDFORMAT = &H0&                 '/* invalid format */
Private Const WAVE_FORMAT_1M08 = &H1&                   '/* 11.025 kHz, Mono,   8-bit
Private Const WAVE_FORMAT_1S08 = &H2&                   '/* 11.025 kHz, Stereo, 8-bit
Private Const WAVE_FORMAT_1M16 = &H4&                   '/* 11.025 kHz, Mono,   16-bit
Private Const WAVE_FORMAT_1S16 = &H8&                   '/* 11.025 kHz, Stereo, 16-bit
Private Const WAVE_FORMAT_2M08 = &H10&                  '/* 22.05  kHz, Mono,   8-bit
Private Const WAVE_FORMAT_2S08 = &H20&                  '/* 22.05  kHz, Stereo, 8-bit
Private Const WAVE_FORMAT_2M16 = &H40&                  '/* 22.05  kHz, Mono,   16-bit
Private Const WAVE_FORMAT_2S16 = &H80&                  '/* 22.05  kHz, Stereo, 16-bit
Private Const WAVE_FORMAT_4M08 = &H100&                 '/* 44.1   kHz, Mono,   8-bit
Private Const WAVE_FORMAT_4S08 = &H200&                 '/* 44.1   kHz, Stereo, 8-bit
Private Const WAVE_FORMAT_4M16 = &H400&                 '/* 44.1   kHz, Mono,   16-bit
Private Const WAVE_FORMAT_4S16 = &H800&                 '/* 44.1   kHz, Stereo, 16-bit

Private Const WAVE_FORMAT_PCM = 1

Private Const WHDR_DONE = &H1&              '/* done bit */
Private Const WHDR_PREPARED = &H2&          '/* set if this header has been prepared */
Private Const WHDR_BEGINLOOP = &H4&         '/* loop start block */
Private Const WHDR_ENDLOOP = &H8&           '/* loop end block */
Private Const WHDR_INQUEUE = &H10&          '/* reserved for driver */

Private Const WIM_OPEN = &H3BE
Private Const WIM_CLOSE = &H3BF
Private Const WIM_DATA = &H3C0

Private Declare Function waveInAddBuffer Lib "winmm" (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, ByVal WaveHdrStructSize As Long) As Long
Private Declare Function waveInPrepareHeader Lib "winmm" (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, ByVal WaveHdrStructSize As Long) As Long
Private Declare Function waveInUnprepareHeader Lib "winmm" (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, ByVal WaveHdrStructSize As Long) As Long

Private Declare Function waveInGetNumDevs Lib "winmm" () As Long
Private Declare Function waveInGetDevCaps Lib "winmm" Alias "waveInGetDevCapsA" (ByVal uDeviceID As Long, ByVal WaveInCapsPointer As Long, ByVal WaveInCapsStructSize As Long) As Long

Private Declare Function waveInOpen Lib "winmm" (WaveDeviceInputHandle As Long, ByVal WhichDevice As Long, ByVal WaveFormatExPointer As Long, ByVal CallBack As Long, ByVal CallBackInstance As Long, ByVal Flags As Long) As Long
Private Declare Function waveInClose Lib "winmm" (ByVal WaveDeviceInputHandle As Long) As Long

Private Declare Function waveInStart Lib "winmm" (ByVal WaveDeviceInputHandle As Long) As Long
Private Declare Function waveInReset Lib "winmm" (ByVal WaveDeviceInputHandle As Long) As Long
Private Declare Function waveInStop Lib "winmm" (ByVal WaveDeviceInputHandle As Long) As Long


Sub InitDevices()
    Dim Caps As WaveInCaps, Which As Long
    DevicesBox.Clear
    For Which = 0 To waveInGetNumDevs - 1
        Call waveInGetDevCaps(Which, VarPtr(Caps), Len(Caps))
        If Caps.Formats And WAVE_FORMAT_1S16 Then 'Now is 1S16 -- Check for devices that can do stereo 16-bit 11kHz
            Call DevicesBox.AddItem(StrConv(Caps.ProductName, vbUnicode), Which)
        End If
    Next
    If DevicesBox.ListCount = 0 Then
        MsgBox "You have no audio input devices!", vbCritical, "Ack!"
        End
    End If
    DevicesBox.ListIndex = 0
End Sub


Private Sub Flicker_Click()
    Scope(0).Cls
    Scope(1).Cls
    If Flicker.Value = vbChecked Then
        Scope(0).AutoRedraw = True
        Scope(1).AutoRedraw = True
    Else
        Scope(0).AutoRedraw = False
        Scope(1).AutoRedraw = False
    End If
End Sub


Private Sub Form_Load()
    Call InitDevices
    
    'Set MinWidth and MinHeight based on Shape...
    Dim XAdjust As Long, YAdjust As Long
    XAdjust = Me.Width \ Screen.TwipsPerPixelX - Me.ScaleWidth
    YAdjust = Me.Height \ Screen.TwipsPerPixelY - Me.ScaleHeight
    
    MinWidth = Shape.Width + XAdjust
    MinHeight = Shape.Height + YAdjust
    
    Shape.BackStyle = vbTransparent
    
    
    'Set the window proceedure to my own (which restricts the
    'minimum size of the form...
    'Comment out the SetWindowLong line if you're working with it
    'in the development environment since it'll hang in stop mode.
    MinMaxProc.Proc = GetWindowLong(Me.HWnd, GWL_WNDPROC)
    'SetWindowLong Me.HWnd, GWL_WNDPROC, AddressOf WindowProc

End Sub


Private Sub Form_Resize()
    Scope(0).Cls
    Scope(1).Cls
    
    Stuff.Top = Me.ScaleHeight - Stuff.Height - 3
    Scope(0).Height = Me.ScaleHeight - 75
    Scope(1).Height = Scope(0).Height
'    Scope(0).Width = (Me.ScaleWidth - 13) \ 2
    Scope(0).Width = Me.ScaleWidth - 13
    Scope(1).Width = Scope(0).Width
    Scope(1).Left = Scope(0).Left + Scope(0).Width + 1
    
    DevicesBox.Width = Me.ScaleWidth - 13
    
    Scope(0).ScaleHeight = 65536    '256
    Scope(0).ScaleWidth = 65536     '255
    Scope(1).ScaleHeight = 256
    Scope(1).ScaleWidth = 255
   
    'Make the window resize now so that it doesn't interfere with redrawing the data
    DoEvents
    
    'Redraw the data at the new size
'    If Inited = True Then
'        Call DrawData
'    End If
End Sub


Private Sub Form_Unload(Cancel As Integer)
    If DevHandle <> 0 Then
        Call DoStop
    End If
End Sub


Private Sub StartButton_Click()
    Static WaveFormat As WaveFormatEx
    With WaveFormat
        .FormatTag = WAVE_FORMAT_PCM
        .Channels = 2 'Two channels -- left and right
        .SamplesPerSec = 11025 '11khz
        .BitsPerSample = 16
        .BlockAlign = (.Channels * .BitsPerSample) \ 16
        .AvgBytesPerSec = .BlockAlign * .SamplesPerSec
        .ExtraDataSize = 0
    End With
    
    Debug.Print "waveInOpen:"; waveInOpen(DevHandle, DevicesBox.ListIndex, VarPtr(WaveFormat), 0, 0, 0)
    
    If DevHandle = 0 Then
        Call MsgBox("Wave input device didn't open!", vbExclamation, "Ack!")
        Exit Sub
    End If
    Debug.Print " "; DevHandle
    Call waveInStart(DevHandle)
    
    Inited = True
       
    StopButton.Enabled = True
    StartButton.Enabled = False
    
    Call Visualize
End Sub


Private Sub StopButton_Click()
    Call DoStop
End Sub


Private Sub DoStop()
    Call waveInReset(DevHandle)
    Call waveInClose(DevHandle)
    DevHandle = 0
    StopButton.Enabled = False
    StartButton.Enabled = True
End Sub


Private Sub Visualize()
    Static Wave As WaveHdr
    
    Wave.lpData = VarPtr(InData(0))
    Wave.dwBufferLength = BLEN * 2 'Increase buffer size to capture 400mS of 16 bits data
    Wave.dwFlags = 0
         
    XCal = 60   'From calibration process
    YCal = 5.4

    Do
    
        Call waveInPrepareHeader(DevHandle, VarPtr(Wave), Len(Wave))
        Call waveInAddBuffer(DevHandle, VarPtr(Wave), Len(Wave))
    
        Do
            'Nothing -- we're waiting for the audio driver to mark
            'this wave chunk as done.
        Loop Until ((Wave.dwFlags And WHDR_DONE) = WHDR_DONE) Or DevHandle = 0
        
        Call waveInUnprepareHeader(DevHandle, VarPtr(Wave), Len(Wave))
        
        If DevHandle = 0 Then
           'The device has closed...
            Exit Do
            Exit Sub
        End If
    Scope(0).Cls
    Scope(1).Cls
    
    Call DrawGrid(2.5, 45)
    Call DrawPd(2)
    Call DrawLine(150, 100)            'A,B
'        Scope(0).Cls
    Scope(0).DrawWidth = 1
    Call DrawXY
    Scope(0).DrawWidth = 1
'        Dosync "+"
'        Call DrawData
        DoEvents
    Loop While DevHandle <> 0 'While the audio device is open

End Sub
Private Sub Dosync(Edge As String)
    Static X As Long
    Static I As Long
    
    For X = 0 To 511    'At least 511 bytes remains
        If InData(X) = 127 Then  'wait for zero crossing
            If InData(X + 2) < 127 Then 'if positive going edge
                For I = 0 To 511
                    SyncData(I) = InData(X)
                    X = X + 1
                Next I
                Exit Sub
            End If
        End If
    Next X
End Sub
Private Sub DrawLine(A As Long, B As Long)
    Static I As Long
    
    Scope(0).Tag = Scope(0).ForeColor
    Scope(0).ForeColor = vbBlack
    Scope(0).CurrentX = -1
    Scope(0).CurrentY = B
    For I = 1 To 65536        '256 To 1 Step -1    'voids divide by 0
        Scope(0).Line Step(0, 0)-(I, Scope(0).CurrentY + (A / 65536))
    Next I
    Scope(0).ForeColor = Scope(0).Tag

End Sub
Private Sub DrawPd(P As Single)
    Static I As Long
    
    Scope(0).CurrentX = 0
    Scope(0).CurrentY = 0
    Scope(0).Tag = Scope(0).ForeColor
    Scope(0).ForeColor = vbRed
    Scope(0).Print "Pd=" & Format(P, "##0.#") & "W"
    Scope(0).CurrentX = 0
    Scope(0).CurrentY = -1
    P = 10000 * P
    For I = 65536 To 1 Step -1    'voids divide by 0
        Scope(0).Line Step(0, 0)-(P \ I, 65536 - I)
    Next I
    Scope(0).ForeColor = Scope(0).Tag
End Sub
Private Sub DrawGrid(VUnit As Single, Hunit As Single)

    Static I As Integer
    Static X As Long
    Static Y As Long
    Static SubNum As Integer
    
    XScale = XCal / Hunit
    YScale = YCal / VUnit
    For I = 0 To 1
        SubNum = 8
        Scope(I).Tag = Scope(I).ForeColor
        Scope(I).ForeColor = RGB(0, 128, 0) 'vbGreen
        X = Scope(I).ScaleHeight \ SubNum
        For SubNum = 1 To SubNum    'Draw horizontal lines
            Scope(I).CurrentX = 1
             Y = X * SubNum
             Scope(I).CurrentY = Y - Scope(I).TextHeight("1")
             Scope(I).Print Format((8 - SubNum) * VUnit, "0.#")
             Scope(I).CurrentX = -1
             Scope(I).CurrentY = Y
            Scope(I).Line Step(0, 0)-(65536, Y)
        Next SubNum
        For SubNum = 1 To SubNum    'Draw vertical lines
            Scope(I).CurrentY = -1
             Y = X * SubNum
             Scope(I).CurrentX = Y
            Scope(I).Line Step(0, 0)-(Y, 65536)
             Scope(I).CurrentY = 65536 - Scope(I).TextHeight("1")
            Scope(I).Print (SubNum) * Hunit
        Next SubNum
        
        Scope(I).ForeColor = Scope(I).Tag
    Next I
    
End Sub

Private Sub DrawData()
    Static X As Long
    
    Scope(0).CurrentX = -1
    Scope(0).CurrentY = Scope(0).ScaleHeight \ 2
    Scope(1).CurrentX = -1
    Scope(1).CurrentY = Scope(0).ScaleHeight \ 2
    
    'Plot the data...
    For X = 0 To 255
        Scope(0).Line Step(0, 0)-(X, SyncData(X * 2))
'        Scope(0).Line Step(0, 0)-(X, (SyncData(X * 2) * 2))
'        Scope(1).Line Step(0, 0)-(X, SyncData(X * 2 + 1)) 'For a good soundcard...
        
    Next
            
    Scope(0).CurrentY = Scope(0).Width
    Scope(1).CurrentY = Scope(0).Width
End Sub

Private Sub DrawXY()
    Static J As Long
    Static I As Long
    Static X As Single
    Static Y As Single
    Static PrevX As Single
    Static PrevY As Single
    Static WaitFirst As Boolean
    Static Skip As Boolean
    Static XShift As Single
    Static YShift As Single
    Static Count As Integer
    Static Llimit As Single
    Static Rising As Boolean
    Static HigherX As Single
    
    XShift = 0
    YShift = 0
    WaitFirst = True
    Skip = True
    HigherX = 0

    J = 1
    For J = 1 To (BLEN / 2) - 1
        X = InData(J * 2)
        Y = -InData((J * 2) + 1)
        If Not WaitFirst Then
            If Y < PrevY - 300 And X > PrevX + 500 Then
'            If X < 50 And X > -50 And X < PrevX Then    'Wait for a "rising zero crossing"
                Exit For    'done.
            End If
        End If
        WaitFirst = False
        PrevX = X
        PrevY = Y
    Next
    For J = J To (BLEN / 2) - 1
        X = InData(J * 2) * XScale
        Y = -InData((J * 2) + 1) * YScale
        If X > PrevX Then
            If Rising = False Then
                Rising = True
            End If
        Else
            If Rising = True And X > 0 Then
                I = 2 * (J + 60) 'Where we must finish: the 0 anode voltage
                If I > BLEN - 1 Then
                    Exit Sub   'Out of data
                End If
                XShift = (InData(I) * XScale) - 500
                YShift = (-InData(I + 1) * YScale) - 66000 'Shift Y origin at bottom
                Scope(0).CurrentX = X - XShift 'Reset actual location
                Scope(0).CurrentY = Y - YShift
                Scope(0).DrawWidth = 5
                Scope(0).PSet Step(0, 0), vbRed
                Scope(0).DrawWidth = 2
                Skip = False
            End If
            Rising = False
        End If
        If Not Rising And Not Skip Then 'And Y - YShift < 64500 Then
            Scope(0).Line Step(0, 0)-(X - XShift, Y - YShift)
        End If
        PrevX = X
        PrevY = Y
    Next J

End Sub

